<?php
/*
Plugin Name: Digg Widget
Plugin URI: http://nothingoutoftheordinary.com/2007/05/31/wordpress-digg-widget/
Description: Adds a sidebar widget to show your current digg
Author: James Wilson
Version: 1.1
Author URI: http://nothingoutoftheordinary.com
*/

/*
Changes:
1.1 - It's $after_widget, not $afterwidget. Thanks Eric.
1.0 - Original
*/

// _Very_ largely based on the gsearch widget by Automattic

// Put functions into one big function we'll call at the plugins_loaded
// action. This ensures that all required plugin functions are defined.
function widget_digg_init() {

	// Check for the required plugin functions. This will prevent fatal
	// errors occurring when you deactivate the dynamic-sidebar plugin.
	if ( !function_exists('register_sidebar_widget') )
		return;

	// This is the function that outputs our little Google search form.
	function widget_digg($args) {
		
		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);

		// Each widget can store its own options. We keep strings here.
		$options = get_option('widget_digg');
		$username = urlencode($options['userid']);
		$widgettitle = ($options['title'] != "") ? $before_title.$options['title'].$after_title : "";  // ($options['title'] != "") ? $options['title'] : "digg Rankings";
		$cachetime = $options['cachetime'];
		$lastcheck = $options['lastcheck'];
		$length = $options['length'];
		
		if(time() - $cachetime < $lastcheck AND $options['cache'] != "") {
			echo $before_widget.$widgettitle.$options['cache'].$after_widget;
		}
		else {
			$uri = 'http://digg.com/rss/' . $username . '/index2.xml';
			ini_set('user_agent','WordPress Digg Widget - http://nothingoutoftheordinary.com/wordpress-digg-widget/');
			$data = file_get_contents($uri);
			
			
			if($data != "") {
				$itemformatting = $options['item'];	
				$items = "";
				$count = 0;
				// Go through all of the stories
				while(strpos($data,"<item>") != FALSE AND $count < $length) {
					$start = strpos($data,"<item>");
					$stop = strpos($data,"</item>");
					$entry = substr($data, $start, $stop-$start);
					
					
					// Title
					$start = strpos($entry,"<title>") + 7;
					$title = substr($entry, $start, strpos($entry,"</title>")-$start);
					
					// Link
					$start = strpos($entry, "<link>") + 6;
					$link = substr($entry, $start, strpos($entry, '</link>')-$start);
					
					// Description
					$start = strpos($entry, "<description>") + 13;
					$description = substr($entry, $start, strpos($entry, "</description>") - $start);
					
					// Time submitted
					$start = strpos($entry, "<pubDate>") + 9;
					$date = substr($entry, $start, strpos($entry, "</pubDate>") - $start);
					
					// Diggs
					$start = strpos($entry, "<digg:diggCount>") + 16;
					$diggs = substr($entry, $start, strpos($entry, "</digg:diggCount>")-$start);
					
					// Digg username
					$start = strpos($entry, "<digg:username>") + 15;
					$digguser = substr($entry, $start, strpos($entry, "</digg:username>") - $start);
					
					// Digg user image
					$start = strpos($entry, "<digg:userimage>") + 16;
					$diggimage = substr($entry, $start, strpos($entry, "</digg:userimage>") - $start);
					
					// Comments
					$start = strpos($entry, "<digg:commentCount>") + 19;
					$comments = substr($entry, $start, strpos($entry, "</digg:commentCount>") - $start);
					
					// Category
					$start = strpos($entry, "<digg:category>") + 15;
					$category = substr($entry, $start, strpos($entry, "</digg:category>") - $start);
					
					
					$stop += 6;
					$data = substr($data,$stop);
					
					$items .= str_replace(
						array ( 
							"%title%", 
							"%link%", 
							"%desc%",
							"%date%",
							"%diggs%",
							"%comments%",
							"%category%",
							"%user%",
							"%userimage%",
							"%number%"
						), 
						array( 
							$title, 
							$link, 
							$description,
							$date,
							$diggs,
							$comments,
							$category,
							$digguser,
							$diggimage,
							$count+1 ), 
						$itemformatting
					);
					$count ++;
				}
			}
			
			
			$startformatting = $options['start'];
			$start = str_replace( array( "%count%", "%username%", "%rss%", "%profile%") , array( $count, $username, $uri, $profilelink), $startformatting);
			
			$endformatting = $options['end'];
			$end = str_replace( array( "%count%", "%username%", "%rss%", "%profile%") , array( $count, $username, $uri, $profilelink), $endformatting);
			
			$content = $start.$items.$end;
			
			
			$options['cache'] = $content;
			$options['lastcheck'] = time();
			update_option('widget_digg',$options);
			
			
			echo $before_widget;
			echo $widgettitle;
			echo $content;
			echo $after_widget;
		}
	}

	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_digg_control() {

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_digg');
		if ( !is_array($options) )
			$options = array('title'=>'Latest Dugg Items', 
				'cache'=> '',
				'lastcheck' => 0,
				'userid' => 'sk33t',
				'start' => '<ul style="list-style-type: none;">',
				'end' => '</ul>'."\n".'<a href="%profilelink%" style="float:right;">%username%</a>',
				'item' => '<li style="list-style-type: none;"><a href="%link%">%title% (%diggs%)</a></li>',
				'length' => '5',
				'cachetime' => '3600'
			);
		if ( $_POST['digg-submit'] ) {
			// Remember to sanitize and format use input appropriately.
			$options['title'] = strip_tags(stripslashes($_POST['digg-title']));
			$options['userid'] = strip_tags(stripslashes($_POST['digg-userid']));
			//$options['cache'] = strip_tags(stripslashes($_POST['digg-cache']));
			$options['cachetime'] = strip_tags(stripslashes($_POST['digg-cachetime']));
			$options['start'] = stripslashes($_POST['digg-start']);
			$options['end'] = stripslashes($_POST['digg-end']);
			$options['item'] = stripslashes($_POST['digg-item']);
			$options['length'] =  strip_tags(stripslashes($_POST['digg-length']));
			$options['lastcheck'] = 0;
			
			update_option('widget_digg', $options);
		}

		// Be sure you format your options to be valid HTML attributes.
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$userid = htmlspecialchars($options['userid'], ENT_QUOTES);
		$start = htmlspecialchars($options['start'], ENT_QUOTES);
		$end = htmlspecialchars($options['end'], ENT_QUOTES);
		$item = htmlspecialchars($options['item'], ENT_QUOTES);
		$length = htmlspecialchars($options['length'], ENT_QUOTES);
		$cachetime = htmlspecialchars($options['cachetime'], ENT_QUOTES);
		
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align:right;"><label for="digg-title">' . __('Title:') . ' <input style="width: 200px;" id="digg-title" name="digg-title" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="digg-userid">' . __('Username:', 'widgets') . ' <input style="width: 200px;" id="digg-userid" name="digg-userid" type="text" value="'.$userid.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="digg-length">' . __('Items:', 'widgets') . ' <input style="width: 200px;" id="digg-length" name="digg-length" type="text" value="'.$length.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="digg-cachetime">' . __('Cache time:', 'widgets') . ' <input style="width: 200px;" id="digg-cachetime" name="digg-cachetime" type="text" value="'.$cachetime.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="digg-start">' . __('Items start <a href="http://nothingoutoftheordinary.com/2007/05/31/wordpress-digg-widget/">?</a>:', 'widgets') . ' <textarea style="width: 200px;" id="digg-start" name="digg-start" row="5" cols="20">'.$start.'</textarea></label></p>';
		echo '<p style="text-align:right;"><label for="digg-end">' . __('Items end:', 'widgets') . ' <textarea style="width: 200px;" id="digg-end" name="digg-end" row="5" cols="20">'.$end.'</textarea></label></p>';
		echo '<p style="text-align:right;"><label for="digg-item">' . __('Item:', 'widgets') . ' <textarea style="width: 200px;" id="digg-item" name="digg-item" row="5" cols="20">'.$item.'</textarea></label></p>';
		echo '<input type="hidden" id="digg-submit" name="digg-submit" value="1" />';
	}
	
	// This registers our widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('digg', 'widgets'), 'widget_digg');

	// This registers our optional widget control form. Because of this
	// our widget will have a button that reveals a 300x100 pixel form.
	register_widget_control(array('digg', 'widgets'), 'widget_digg_control', 350, 375);
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_digg_init');

?>